unit uContainDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, quickrTTI,XMLContainers, ComCtrls, ExtCtrls, Buttons, ImgList, ActnList;

type
  TContact=class(TXMLAware)
    private
    Fname:string;
    Femail:String;
    FForname:String;
    FNotes:TStringlist;
    FDate: TDate;
    function GetNotes: TStringList;
    procedure SetNotes(const Value: TStringList);
    public
    destructor Destroy; override;
    procedure AfterConstruction; override;
    published
    property Date:TDate read FDate write FDate;
    property Name:string read FName write FName;
    property Forname:string read FForname write FForname;
    property Email:string read FEmail write FEmail;
    property Notes:TStringList read GetNotes write SetNotes;
    end;




  TForm1 = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    XML: TTabSheet;
    Edit: TTabSheet;
    Find: TTabSheet;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    Edit1: TEdit;
    Edit2: TEdit;
    DateTimePicker1: TDateTimePicker;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EdFindName: TEdit;
    Label7: TLabel;
    EdFindForname: TEdit;
    BitBtn1: TBitBtn;
    btnAddContact: TBitBtn;
    ActionList1: TActionList;
    btnSave: TBitBtn;
    actNewContact: TAction;
    memoNotes: TMemo;
    ActFindContact: TAction;
    actClearInputForm: TAction;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label8: TLabel;
    BitBtn4: TBitBtn;
    ActDeleteContact: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveToXML;
    procedure Button4Click(Sender: TObject);
    procedure actNewContactExecute(Sender: TObject);
    procedure ActFindContactExecute(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure actClearInputFormExecute(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActDeleteContactExecute(Sender: TObject);
  
  private

  HashTable:TXMLHashStringList;
  CurrentContact:TContact;
    { Private declarations }
  public
  procedure LoadContact(ContactToLoad:TContact);
  procedure SaveContact(ContactToSave:TContact);
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
HashTable:=TXMLHashStringList.Create(TContact,10,GetHashCode);
HashTable.Duplicates:=dupError;

if FileExists(extractFilePath(paramStr(0))+'Contacts.XML') then
  begin
  memo1.lines.LoadFromFile(extractFilePath(paramStr(0))+'Contacts.XML');
  HashTable.LoadFromXML('HashTable',memo1.lines.text);
  end;

ActClearInputFormexecute(self);
end;



procedure TForm1.FormDestroy(Sender: TObject);
begin
HashTable.Free;
end;


procedure TForm1.SaveToXML;
begin
memo1.lines.text:=HashTable.SaveToXML('HashTable');
memo1.lines.saveToFile(extractFilepath(paramStr(0))+'Contacts.XML');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin


end;

{ TContact }

procedure TContact.AfterConstruction;
begin
  inherited;
//showmessage('creating');
FNotes:=TStringList.Create;
end;


destructor TContact.Destroy;
begin
  inherited;
FNotes.Free;
end;

function TContact.GetNotes: TStringList;
begin
Result:=FNotes;
end;

procedure TContact.SetNotes(const Value: TStringList);
begin
if Value<>FNotes then
FNotes.assign(Value);
end;

procedure TForm1.LoadContact(ContactToLoad: TContact);
begin
With ContactToLoad do
 begin
 edit1.Text:=name;
 edit2.text:=forname;
 DateTimePicker1.Date:=Date;
 edit3.text:=email;
 memoNotes.Lines.Assign(notes);
 end;
end;

procedure TForm1.SaveContact(ContactToSave: TContact);
begin
if Assigned(ContactToSave) then
With ContactToSave do
 begin
 Name:=edit1.Text;
 Forname:=edit2.text;
 Date:=DateTimePicker1.Date;
 email:=edit3.text;
 Notes:=TStringList(MemoNotes.Lines);
 end;
end;

procedure TForm1.actNewContactExecute(Sender: TObject);
var hashString:String;
begin
CurrentContact:=TContact.Create;
SaveContact(CurrentContact);
hashString:= UpperCase(CurrentContact.name)+UpperCase(CurrentContact.Forname);
HashTable.AddObject(hashString,CurrentContact.date,currentContact);
SaveToXML;
end;

procedure TForm1.ActFindContactExecute(Sender: TObject);
var hashString:String;
begin
HashString:=Uppercase(edFindName.text)+UpperCase(edFindForname.text);
currentContact:=TContact(HashTable.objects[hashString]);
if Assigned(CurrentContact) then
  begin
  LoadContact(currentContact);
  pageControl1.ActivePageIndex:=0;
  end
else
 showMessage('Not found.');
end;

procedure TForm1.btnSaveClick(Sender: TObject);
begin
SaveContact(CurrentContact);
SaveToXML;
end;

procedure TForm1.actClearInputFormExecute(Sender: TObject);
begin
edit1.text:='';
edit2.text:='';
edit3.text:='';
DateTimePicker1.date:=Date;
memoNotes.lines.Clear;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
HashTable.LoadFromXML('HashTable',memo1.lines.text);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if MessageDlg('Save changes before exiting application?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then  BtnSave.Click;
 canclose:=true;

end;

procedure TForm1.ActDeleteContactExecute(Sender: TObject);
var hashString:String;
begin
HashString:=Uppercase(edFindName.text)+UpperCase(edFindForname.text);
HashTable.delete(HashString);
SaveToXML;
end;

initialization
RegisterClass(TContact);
finalization
UnRegisterClass(Tcontact);

end.
