unit uDoubleLink;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,XMLContainers,
  StdCtrls, Buttons, ExtCtrls;

type
  TContact=class
    private
    Age:longint;
    name:string;
    email:String;
    public
    Destructor destroy; override;
    end;

  TForm1 = class(TForm)
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Button4: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Button5: TButton;
    Panel1: TPanel;
    ListBox1: TListBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Panel2: TPanel;
    Label7: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    Label3: TLabel;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure InsertNew(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SearchByName(Sender: TObject);
    procedure CalcAverageAge(Sender: TObject);
    function ShowPosition:string;
    procedure ShowList;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure NewContact(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SearchByEmail(Sender: TObject);
  private
  FList:TXMLDoubleLinkList;
  function ShowObjects( const pItem    : pDZItem;
                    const CallBackData : Pointer ):boolean;
  procedure ShowContact(color:TColor);
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;

implementation



{$R *.DFM}
function compareByFString(Lhs:PDZItem;Rhs:PDZItem):Integer;
begin
Result:=AnsiCompareStr(Lhs^.FString,Rhs^.Fstring);
end;

function CompareByEmail(Lhs:PDZItem;Rhs:PDZItem):Integer;
begin
if Assigned(Lhs^.FObject) and Assigned(Rhs^.Fobject) then
  begin
  Result:=AnsiCompareStr(TContact(Lhs^.FObject).email,TContact(Rhs^.FObject).email)
  end
else Result:=-1
end;

function SumValues( const pItem    : pDZItem;
                    const CallBackData : Pointer ):boolean;
var
  {CallBackData is a pointer to a longint: so typecast it}
  Sum :  ^longint absolute CallBackData;
c:TContact;
begin
  c:=TContact(PItem^.Fobject);
  inc(Sum^, c.Age);
  Result := false; //don't stop
  {it could be added a conditional result:=true to stop the iteration at the
   meeting of a certain condition}
end;

function TForm1.ShowObjects( const pItem    : pDZItem;
                    const CallBackData : Pointer ):boolean;
var
c:TContact;

begin
  if  assigned(PItem^.FObject) then
     begin
     C:=PItem^.Fobject as TContact;
     ListBox1.items.Add(VarToStr(PItem^.FVariantValue)+'  '+c.name);
     end
  else ListBox1.items.add(VarToStr(PItem^.FVariantValue)+'  '+'nil');
  Result:=False;//don't stop
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
FList:=TXMLDoubleLinkList.Create(TContact);
FList.CompareFunction:=compareByFString;;


end;

procedure TForm1.FormDestroy(Sender: TObject);

begin
FList.Free;
end;

{ TLamento }

destructor TContact.destroy;
begin
ShowMessage(Name+' destroyed.');
inherited;
end;

procedure TForm1.InsertNew(Sender: TObject);
var
    Contact:TContact;
begin
  if (edit3.text<>'') and (edit4.text<>'') and (edit5.text<>'') then
  begin
  Contact:=TContact.Create;
  Contact.age:=StrToInt(edit3.text);
  Contact.name:=edit4.text;
  Contact.email:=edit5.text;
  FList.InsertAfterCursor(Contact.Age,Contact.name,Contact);
  FLIst.MoveNext;
  Label1.Caption:='Number of items in list: '+intToStr(FList.count);
  label1.Caption:=Label1.caption+#10#13+ShowPageStatistics;
  Label3.caption:=ShowPosition;
  ShowList;
  end
  else showMessage('Complete the information by editing age, name and email.');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
FList.Clear;
Label1.Caption:='Number of items in list: '+intToStr(FList.count)+#10#13+ShowPageStatistics;
ShowPosition;
ShowList;
end;



procedure TForm1.SearchByName(Sender: TObject);
begin
FList.CompareFunction:=compareByFString;;
if FList.Search(0,edit1.text,nil) then
  begin
   ShowContact(clAqua);
   label3.caption:=ShowPosition;
   end;
end;

procedure TForm1.CalcAverageAge(Sender: TObject);
var
    TotalValue : longint;
    average:extended;
begin
  average:=0;
  TotalValue := 0; {clear the total}
  FList.ForEachCall(SumValues, true, @TotalValue);
  if FList.count<>0 then Average:=TotalValue/Flist.Count;
  label2.caption:='sum: '+ intToStr(TotalValue)+' Average age: '+FloatToStr(average);

end;

function TForm1.ShowPosition:string;
begin
if fList.IsEOL  then
   begin
   Result:='EOL';
   end
else if FList.IsBOL then
         begin
         Result:='BOL';
         end
    else begin
         Result:=FList.stringContent;
         end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
if not fList.IsBOL then  Flist.MovePrevious;
ShowContact(clyellow);
Label3.caption:=ShowPosition;
//ShowList(self);
{if not fList.IsBOL  then
  listBox1.itemIndex:=FList.KeyContent
else  listBox1.itemIndex:=-1;

if (not FList.IsEOL) and (not FList.IsBOL) then
label3.caption:=IntToStr(FList.KeyContent)
else if FList.IsEOL then label3.caption:='EOL' else label3.caption:='BOL'; }
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
if not fList.IsEOL  then  Flist.MoveNext;
ShowContact(clyellow);
Label3.caption:=ShowPosition;
//ShowList(self);
{if not fList.IsEOL  then
  listBox1.itemIndex:=FList.KeyContent
else  listBox1.itemIndex:=-1;

if (not FList.IsEOL) and (not FList.IsBOL) then
label3.caption:=IntToStr(FList.KeyContent)
else if FList.IsEOL then label3.caption:='EOL' else label3.caption:='BOL';  }
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
FList.Delete;
Label3.caption:=showPosition;
ShowList;
Label1.Caption:='Number of items in list: '+intToStr(FList.count)+#10#13+ShowPageStatistics;
end;

procedure TForm1.NewContact(Sender: TObject);
begin
edit3.text:='';
edit4.text:='';
edit5.text:='';
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
Flist.OwnsObjects:=CheckBox1.checked;
end;

procedure TForm1.ShowContact(color: TColor);
var c:TContact;
begin
c:=FList.Content as TContact;
if Assigned(c) then
begin
  edit3.color:=color;
  edit3.text:=intToStr(c.age);
  edit4.color:=color;
  edit4.text:=c.name;
  edit5.Color:=color;
  edit5.text:=C.email;
end
else
  begin
  edit3.color:=clWindow;
  edit3.text:='';
  edit4.color:=clWindow;
  edit4.text:='';
  edit5.Color:=clWindow;
  edit5.text:='';
  end;
end;

procedure TForm1.SearchByEmail(Sender: TObject);
var model:TContact;
begin
fList.CompareFunction:=CompareByEmail;
model:=TContact.create;
model.name:='Model';
model.email:=edit2.text;
if FList.Search(0,'',model) then
  begin
   ShowContact(clAqua);
   Label3.caption:=showPosition;
  end;
model.free;
end;



procedure TForm1.ShowList;
begin
ListBox1.items.Clear;
FList.ForEachCall(ShowObjects, true, nil);
end;

end.
