unit uHash;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,XMLContainers, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Memo3: TMemo;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure HashTableTest(Sender: TObject);
    procedure StringListTest(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private


     { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function SumIntegers( const pItem    : pDZItem;
                    const CallBackData : Pointer ):boolean;
var
  {CallBackData is a pointer to a longint: so typecast it}
  Sum :  ^longint absolute CallBackData;

begin

  Sum^:=Sum^+PItem^.FVariantValue;
  Result := false; //don't stop
  {it could be added a conditional result:=true to stop the iteration at the
   meeting of a certain condition}
end;


procedure TForm1.HashTableTest(Sender: TObject);
var
x,inizio, fine:extended;
i:integer;
total:longint;
str:String;
DZHash:TXMLHashStringList;
hf:THashFunction;
begin
Screen.Cursor := crHourglass;
try
memo1.Lines.Clear;
if comboBox1.itemindex=1 then    hf:=GetHashCode else hf:=SimpleHashFunction;
DZHash:=TXMLHashStringList.Create(Tobject,10000,hf);
inizio:=GetTickCount;
for i:= 0 to 9999 do
 begin
  //add a string value and an integer just to show how to do it
 DZHash.Add(intToStr(i)+'='+intToStr(i),i);

 end;
fine:=Gettickcount;
x:=(fine-Inizio)/1000;
Memo1.Lines.add('Insertion duration: ');
Memo1.lines.add(format('%10.5n',[x])+' seconds');
//showing how to use an iterator
total:=0;
DZhash.ForEachCall(SumIntegers,true,@total);
Memo1.lines.add('Total of integers in list: ');
memo1.lines.add(intToStr(total));

inizio:=GetTickCount;
for I:=0 to 9999 do
begin
label2.caption:=DZHash.Values[IntToStr(i)];
application.ProcessMessages;
end;
fine:=Gettickcount;
x:=(fine-Inizio)/1000;
Memo1.Lines.add('Search duration: ');
Memo1.lines.add(floatTostr(x)+' seconds');
Memo1.lines.Text:=Memo1.Lines.text+#10#13+
'-----Statistics-----'+#10#13+
DZHash.ShowStatistics+#10#13+ShowPageStatistics;

DZHash.free;
finally
  screen.cursor:=crDefault;
end;

end;

procedure TForm1.StringListTest(Sender: TObject);
var
x,inizio, fine:extended;
I:integer;
sl:TStringList;
str:string;
Begin
Screen.Cursor := crHourglass;
try
memo2.lines.clear;
sl:=TStringList.Create;
inizio:=GetTickCount;
for i:= 0 to 9999 do
 begin
 // if sl.IndexOf(InttoStr(i))=-1 then
  sl.Add(intToStr(i));
 end;
fine:=Gettickcount;
x:=(fine-Inizio)/1000;
Memo2.Lines.add('Insertion duration: ');
Memo2.lines.add(format('%10.5n',[x])+' seconds');
Memo2.lines.add('Starting search, long operation...');
inizio:=GetTickCount;
for I:=0 to 9999 do
begin
Label3.caption:=sl.strings[sl.IndexOf(IntToStr(i))];
application.processmessages;
end;
fine:=GetTickCount;
x:=(fine-Inizio)/1000;
Memo2.Lines.add('Search duration: ');
Memo2.lines.add(floatTostr(x)+' seconds');
sl.free;

finally
    Screen.Cursor := crDefault;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
comboBox1.ItemIndex:=1;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
memo1.lines.clear;
end;

end.
