unit polygons;

interface
uses classes,QuickRTTI;
type
TPolyPoint = class(TPersistent)
  private
    fx,fy,fz:integer;
  published
    property X:integer read fx write fx;
    property Y:integer read fy write fy;
    property Z:integer read fz write fz;
  end;

 TPolyLine = class(TCollectionItem)
  private
   forigin,fdest:TPolyPoint;
  public
    constructor Create(Collection:TCollection);override;
    destructor  Destroy;override;
  published
   property Origin:TPolyPoint read forigin write forigin;
   property Destination:TPolyPoint read fdest write fdest;
  end;

 TPolyGon = class(TCollectionItem)
  private
    flines:TCollection; fname:String;
  public
    constructor Create(Collection:TCollection);override;
    destructor  Destroy;override;
  published
    property Name:String read fname write fname;
    property Lines:TCollection read flines write flines;
  end;

 TProject = class(TXMLAware)
  private
    fpgons:TCollection;
  public
    constructor Create (RTTIEnabler:TCustomXMLRTTI);override;
    destructor  Destroy;override;
  published
    property Polygons:TCollection read fpgons write fpgons;
  end;

implementation

constructor TProject.Create (RTTIEnabler:TCustomXMLRTTI);
begin
  inherited Create(RTTIEnabler);
  Registerclass(TPolyGon);
  fpgons:=TCollection.create(TPolyGon);
end;

destructor  TProject.Destroy;
begin
 try
   fpgons.free;
 finally
   inherited destroy;
 end;
end;

constructor TPolyGon.Create(Collection:TCollection);
begin
 inherited create(Collection);
 Registerclass(TPolyLine);
 flines:=TCollection.create(TPolyLine);
end;

destructor  TPolyGon.Destroy;
begin
 try
  flines.free
 finally
  inherited destroy;
 end;               
end;


constructor TPolyLine.Create(Collection:TCollection);
begin
 inherited create(Collection);
 forigin:=TPolyPoint.create;
 forigin.x:=-1;
 forigin.y:=-1;
 forigin.z:=-1;

 fdest:=TPolyPoint.create;
 fdest.x:=-1;
 fdest.y:=-1;
 fdest.z:=-1;
end;

destructor  TPolyLine.Destroy;
begin
 try
  forigin.free;
  fdest.free;
 finally
  inherited destroy;
 end;
end;


end.
